ManPw = getObject("ManPw","NUMERIC")+0 --читаем команды от кнопок 
ManP = getObject("ManP","NUMERIC")+0
PwRd =getNumVariable("target_power_volt")+0 --читаем мощность/напряжение
-- Rten=16 Pw=Pw*Pw/Rten --перевод напряжения в мощность для не Stab AVR
Pw=PwRd 
 CP=getNumVariable("pressure_value")+0 --текущее давление 
 prg=getStrVariable("program_type")
if (prg=="B" or prg=="T") and getState()~=40 then --если работает строка отбора тела или хвостов, если пауза не регулируем
 S="" PS="" k=1 --масштаб воздействия
 R = getObject("R","NUMERIC")+0 --режим

 DZ=digitalRead(27) --датчик захлёба
 Pz=getObject("Pz","NUMERIC")+0 --запомненное давление захлёба
 t=getObject("t","NUMERIC")+0 if t>0 then setObject("t",t-1) end --таймер
 Pold=getObject("Pold","NUMERIC")+0 CP=(CP+Pold)/2 setObject("Pold",CP) --фильтр скачков датчика давления
 
 Pmin=Pz*0.95 --минимальное давление предзахлёба
 Pmax=Pz*1.05  -- максимальное давление, при паузе 80% от захлебного, при отборе 50%

 dP=5 if CP>Pmax then dP=(CP-Pmax)*k elseif CP<Pmin then dP=(Pmin-CP)*k end --рассчет воздействия 1-5 МВт
 if dP>20 then dP=20 end
 if R==0 then S=S.."Поиск P захлёба,"
   if DZ==0 then Pw=Pw+0.01*dP else  setObject("R",1) setObject("t",480) Pw=Pw-50 S=S.."Захлёб," end
 elseif R==1 then -- ждем 8 мин., когда Самовар ликвидирует захлёб
   if DZ==0 then setObject("t",t-1) else setObject("t",240)  end 
   S=S.."Пауза "..t..","
   if t<1 then setObject("Pz",CP) setObject("R",2) end
 elseif R==2 then   
   if DZ==1 then S=S.."Захлёб,"  setObject("R",1) setObject("t",240) else S=S.."Стабилизация," end
   if CP<Pmin then --при давлении ниже минимальной уставки
      S=S.."Низкое давление "..t..","  
	  if t<1 then --если таймер не взведен
	     Pw=Pw+dP setObject("t",30) end PS="+" end --добавляем мощность пропорционально отклонению давлениия и взводим таймер на 20 сек
   if CP>Pmax then --при давлении выше максимальной уставки
      S=S.."Высокое давление "..t.."," 
	  if t<1 then --если таймер не взведен
	     Pw=Pw-dP setObject("t",30) end PS="-" end --убавляем мощность пропорционально отклонению давлениия и взводим таймер на 20 сек
 end 
 S1=string.format("P=%.2f(%.1f-%.1f),", CP, Pmin, Pmax)
 S2=string.format("ТЭН %d%sВт,", math.floor(PwRd), PS )
 --print("@clear@") 
print(S1..S2..S) 
 setLuaStatus(S1..S2.." "..S) 
else  setLuaStatus("Ожидание программы отбора тела. Р="..CP) end
if ManPw ~= 0 then Pw=Pw+ManPw setObject("ManPw",0) end --реализуем команды от кнопок
if ManP ~= 0 then setObject("Pz",Pz+ManP) setObject("ManP",0) end
if Pw~=PwRd and Pw>40 and Pw<2000 then --при условии, что на ТЭНе 40-2000Вт и исходную мощность надо менять
-- Pw=(Pw*Rten)^0.5 --перевод мощности в напряжение для не Stab AVR
setCurrentPower(Pw)  end --регулируем ТЭН